CREATE OR REPLACE PROCEDURE COMPRA_LEGAL_BA(
   P_NRLISTA     IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDEMPRESA   IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDIMPOSTO   IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_NRSEQARQMAG IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_LIVROMAG    IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDINSCESTA  IN NOTAFISCAL.CDINSCESTA%TYPE)
AS
   V_IPI         VARCHAR(2);
   V_ICMS_SUB    VARCHAR(2);
   V_CONTADOR    NUMBER;
BEGIN
  
   V_IPI := '10'; /*Cdigo do IPI*/
   V_ICMS_SUB := '80'; /*Cdigo do Imposto de Substituiao do ICMS*/
   V_CONTADOR := 0;
   
   /*REGISTRO 1 - Dados da Nota Fiscal*/
   FOR C_NOTAS IN (/*Notas de Sada*/
                   SELECT '1'                                                                            || '|' || 
                          LTRIM(TO_CHAR(SUBSTR(LPAD(N.NRNOTAFISC,10,'0'),2,9),'999999990'))              || '|' || 
                          SUBSTR(DECODE(N.CDSERIE,'-','', N.CDSERIE),1,4)                                || '|' ||  
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),1,8)  || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),9,4)  || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),13,2) || '|' || 
                          TO_CHAR(N.DTEMISSAO, 'DD/MM/YYYY')                                             || '|' || 
                          DECODE(IE.SGESTADO,'BA',SUBSTR(REPLACE(REPLACE(REPLACE(IE.CDINSCESTA,'-',''),'/',''),'.',''),1,9),'')     || '|' ||
                          IE.SGESTADO                                                                    || '|' || 
                          TO_CHAR (N.DTENTRSAID,'DD/MM/YYYY')                                            || '|' || 
                          CF.CDFISCOPERNF                                                                || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRBASECALCICMS,0),2),'99999999999990.00'))          || '|' || 
                          DECODE(NVL(VR.VRBASECALCSUB,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRBASECALCSUB,0),2),'99999999999990.00'))) || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRICMS,0),2),'999999999990.00'))                    || '|' || 
                          DECODE(NVL(VR.VRSUB,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRSUB,0),2),'999999999990.00')))                   || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRPRODUTOS,0),2),'99999999999990.00'))              || '|' || 
                          DECODE(NVL(VR.VRFRETE,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRFRETE,0),2),'999999999990.00')))               || '|' || 
                          DECODE(NVL(VR.VRSEGURO,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRSEGURO,0),2),'999999999990.00')))             || '|' || 
                          DECODE(NVL(VR.VROUTROS,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VROUTROS,0),2),'99999999999990.00')))           || '|' || 
                          DECODE(NVL(VR.VRIPI,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRIPI,0),2),'999999999990.00')))                   || '|' ||
                          LTRIM(TO_CHAR(ROUND((NVL(VR.VRPRODUTOS,0)+NVL(VR.VRFRETE,0)+NVL(VR.VRSEGURO,0)+NVL(VR.VROUTROS,0)+NVL(VR.VRIPI,0)+NVL(VR.VRSUB,0)),2),'999999999990.00')) || '|' ||
                          DECODE(IE.SGESTADO,'BA',SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSESTTRAN,'-',''),'/',''),'.',''),1,9),'')    || '|' ||
                          NVL(T.DADOS_TRANS, '|||||||||||||')                                            || '|' || 
                          DECODE(N.IDPGTOFRETE,'1','0','1')                                              || '|' || 
                          ''                                                                             || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(C.NRINSJURCLIE, '/', ''),'-',''),'.',''),1,8)   || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(C.NRINSJURCLIE, '/', ''),'-',''),'.',''),9,4)   || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(C.NRINSJURCLIE, '/', ''),'-',''),'.',''),13,2)  || '|' || 
                          C.NMRAZSOCCLIE                                                                 || '|' ||
                          EC.DSENDECLIE                                                                  || '|' ||
                          SUBSTR(EC.NMBAIRCLIE,1,40)                                                     || '|' ||
                          SUBSTR(REPLACE(REPLACE(REPLACE(EC.NRCEPCLIE,'-',''),'.',''),' ',''),1,10)      || '|' ||
                          DECODE(SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(EC.NRTELECLIE,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),2,2),'00','',SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(EC.NRTELECLIE,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),2,2))  || '|' ||
                          SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(EC.NRTELECLIE,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),4,8)   || '|' || 
                          EC.SGESTADO                                                                    || '|' ||
                          M.NMMUNICIPIO                                                                  || '|' ||
                          ''                                                                             || '|' ||
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRPRODUTOS,0)+NVL(VR.VRFRETE,0)+NVL(VR.VRSEGURO,0)+NVL(VR.VROUTROS,0)+NVL(VR.VRIPI,0)+NVL(VR.VRSUB,0)-NVL(VR.DESCONTO,0),2),'99999999999990.00')) || '|' || 
                          DECODE(NVL(VR.DESCONTO,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.DESCONTO,0),2),'99999999999990.00')))           || '|' ||
                          '0'                                                                            || '|' ||
                          ''                                                                             || '|' ||
                          ''                                                                             || '|' ||
                          ''                                                                             || '|' ||
                          ''                                                                             || '|' AS DADOS_NOTA, 
                          L.CDLISTA
                     FROM NOTAFISCAL N, CLIENTE C, ENDECLIE EC, LISTA L, MUNICIPIO M, INSCRESTAD IE,
                          (SELECT MAX (I.CDFISCOPERNF) AS CDFISCOPERNF, CDLISTA   
                             FROM NOTAFISCAL N, IMPOSTONF I, LISTA L
                            WHERE N.CDINSCESTA   = P_CDINSCESTA
                              AND N.CDFILIAL     = I.CDFILIAL
                              AND N.IDENTRSAIDOP = 'S'
                              AND N.NRLANCTONF   = I.NRLANCTONF 
                              AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND L.NRLISTA      = P_NRLISTA
                           GROUP BY CDLISTA) CF,
                          (SELECT NVL(TRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, P_CDIMPOSTO, 'B','1'),2)),0) AS VRBASECALCICMS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_ICMS_SUB, 'B','1'),2)),0,''),0) AS VRBASECALCSUB,
                                  NVL(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, P_CDIMPOSTO, 'I','1'),2)),0) AS VRICMS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_ICMS_SUB, 'I','1'),2)),0,''),0) AS VRSUB,
                                  NVL(LTRIM(ROUND(N.VRPRODUTOS,2)),0) AS VRPRODUTOS,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '01'),2)),0) AS VRFRETE,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '08'),2)),0) AS VRSEGURO,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A'),2)),0) AS VROUTROS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_IPI, 'I','1'),2)),0,''),0)  AS VRIPI,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D'),2)),0) AS DESCONTO,
                                  L.CDLISTA
                             FROM NOTAFISCAL N, LISTA L
                            WHERE N.CDINSCESTA   = P_CDINSCESTA
                              AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND N.IDENTRSAIDOP = 'S'
                              AND L.NRLISTA      = P_NRLISTA) VR, 
                          (SELECT SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),1,8)  || '|' || 
                                  SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),9,4)  || '|' || 
                                  SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),13,2) || '|' || 
                                  SUBSTR(T.NMRAZSOCTRAN,1,150)  || '|' || 
                                  T.SGESTADO                    || '|' || 
                                  M.NMMUNICIPIO                 || '|' || 
                                  ''                            || '|' || 
                                  DSESPECVOLU                   || '|' || 
                                  DECODE(LTRIM(TO_CHAR(ROUND(N.VRPBRUTOVOLU,3),'99999990.000')),'0.000','')     || '|' || 
                                  DECODE(LTRIM(TO_CHAR(ROUND(N.VRPLIQUVOLU,3),'99999990.000')),'0.000','')      || '|' || 
                                  N.NRPLACAVEIC                 || '|' || 
                                  N.SGUFVEIC                    || '|' || 
                                  ''                            || '|' || 
                                  ''                      AS DADOS_TRANS, 
                                  N.NRINSJURTRAN, NRINSESTTRAN, N.IDTPIJURTRAN
                             FROM NOTAFISCAL N, TRANSPORT T, LISTA L, 
                                  (SELECT M.NMMUNICIPIO, T.NRINSJURTRAN, T.IDTPIJURTRAN
                                     FROM TRANSPORT T, MUNICIPIO M
                                    WHERE T.CDMUNICIPIO(+)  = M.CDMUNICIPIO
                                      AND T.SGESTADO(+)     = M.SGESTADO
                                      AND T.CDPAIS(+)       = M.CDPAIS)M
                            WHERE N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND L.NRLISTA      = P_NRLISTA
                              AND N.NRINSJURTRAN = T.NRINSJURTRAN(+)
                              AND N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)
                              AND N.CDINSCESTA   = P_CDINSCESTA
                              AND N.IDENTRSAIDOP = 'S'
                              AND M.NRINSJURTRAN = T.NRINSJURTRAN
                              AND M.IDTPIJURTRAN = T.IDTPIJURTRAN) T
                    WHERE N.CDINSCESTA   = P_CDINSCESTA
                      AND N.IDENTRSAIDOP = 'S'
                      AND N.CDCLIENTE    = C.CDCLIENTE
                      AND C.CDCLIENTE    = EC.CDCLIENTE
                      AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                      AND L.NRLISTA      = P_NRLISTA
                      AND N.NRINSJURTRAN = T.NRINSJURTRAN(+)
                      AND N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)
                      AND CF.CDLISTA     = L.CDLISTA
                      AND VR.CDLISTA     = L.CDLISTA
                      AND EC.CDMUNICIPIO = M.CDMUNICIPIO
                      AND EC.SGESTADO    = M.SGESTADO
                      AND EC.CDPAIS      = M.CDPAIS
                      AND IE.CDEMPRESA   = P_CDEMPRESA
                      AND IE.CDINSCESTA  = P_CDINSCESTA
                      AND EC.IDTPENDECLIE(+) = 'P'
                     
                   UNION
                   /*Notas de Devoluo*/
                   SELECT '1'                                                                            || '|' || 
                          LTRIM(TO_CHAR(SUBSTR(LPAD(N.NRNOTAFISC,10,'0'),2,9),'999999990'))              || '|' || 
                          SUBSTR(DECODE(N.CDSERIE,'-','', N.CDSERIE),1,4)                                || '|' ||  
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),1,8)  || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),9,4)  || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),13,2) || '|' || 
                          TO_CHAR(N.DTEMISSAO, 'DD/MM/YYYY')                                             || '|' || 
                          DECODE(IE.SGESTADO,'BA',SUBSTR(REPLACE(REPLACE(REPLACE(IE.CDINSCESTA,'-',''),'/',''),'.',''),1,9),'')     || '|' ||
                          IE.SGESTADO                                                                    || '|' || 
                          TO_CHAR (N.DTENTRSAID,'DD/MM/YYYY')                                            || '|' || 
                          CF.CDFISCOPERNF                                                                || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRBASECALCICMS,0),2),'99999999999990.00'))          || '|' || 
                          DECODE(NVL(VR.VRBASECALCSUB,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRBASECALCSUB,0),2),'99999999999990.00'))) || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRICMS,0),2),'999999999990.00'))                    || '|' || 
                          DECODE(NVL(VR.VRSUB,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRSUB,0),2),'999999999990.00')))                   || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRPRODUTOS,0),2),'99999999999990.00'))              || '|' || 
                          DECODE(NVL(VR.VRFRETE,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRFRETE,0),2),'999999999990.00')))               || '|' || 
                          DECODE(NVL(VR.VRSEGURO,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRSEGURO,0),2),'999999999990.00')))             || '|' || 
                          DECODE(NVL(VR.VROUTROS,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VROUTROS,0),2),'99999999999990.00')))           || '|' || 
                          DECODE(NVL(VR.VRIPI,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRIPI,0),2),'999999999990.00')))                   || '|' ||
                          LTRIM(TO_CHAR(ROUND((NVL(VR.VRPRODUTOS,0)+NVL(VR.VRFRETE,0)+NVL(VR.VRSEGURO,0)+NVL(VR.VROUTROS,0)+NVL(VR.VRIPI,0)+NVL(VR.VRSUB,0)),2),'999999999990.00')) || '|' ||
                          DECODE(IE.SGESTADO,'BA',SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSESTTRAN,'-',''),'/',''),'.',''),1,9),'')    || '|' ||
                          NVL(T.DADOS_TRANS, '|||||||||||||')                                            || '|' || 
                          DECODE(N.IDPGTOFRETE,'1','0','1')                                              || '|' || 
                          ''                                                                             || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),1,8)   || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),9,4)   || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),13,2)  || '|' || 
                          F.NMRAZSOCFORN                                                                 || '|' ||
                          EF.DSENDEFORN                                                                  || '|' ||
                          SUBSTR(EF.NMBAIRFORN,1,40)                                                     || '|' ||
                          SUBSTR(REPLACE(REPLACE(REPLACE(EF.NRCEPFORN,'-',''),'.',''),' ',''),1,10)      || '|' ||
                          DECODE(SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(EF.NRTELEFORN,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),2,2),'00','',SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(EF.NRTELEFORN,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),2,2))  || '|' ||
                          SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(EF.NRTELEFORN,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),4,8)   || '|' || 
                          EF.SGESTADO                                                                    || '|' ||
                          M.NMMUNICIPIO                                                                  || '|' ||
                          ''                                                                             || '|' ||
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRPRODUTOS,0)+NVL(VR.VRFRETE,0)+NVL(VR.VRSEGURO,0)+NVL(VR.VROUTROS,0)+NVL(VR.VRIPI,0)+NVL(VR.VRSUB,0)-NVL(VR.DESCONTO,0),2),'99999999999990.00')) || '|' || 
                          DECODE(NVL(VR.DESCONTO,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.DESCONTO,0),2),'99999999999990.00')))           || '|' ||
                          '0'                                                                            || '|' ||
                          ''                                                                             || '|' ||
                          ''                                                                             || '|' ||
                          ''                                                                             || '|' ||
                          ''                                                                             || '|' AS DADOS_NOTA, 
                          L.CDLISTA
                     FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN EF, LISTA L, MUNICIPIO M, INSCRESTAD IE,
                          (SELECT MAX (I.CDFISCOPERNF) AS CDFISCOPERNF, CDLISTA   
                             FROM NOTAFISCAL N, IMPOSTONF I, LISTA L
                            WHERE N.CDINSCESTA   = P_CDINSCESTA
                              AND N.CDFILIAL     = I.CDFILIAL
                              AND N.IDENTRSAIDOP = 'S'
                              AND N.NRLANCTONF   = I.NRLANCTONF 
                              AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND L.NRLISTA      = P_NRLISTA
                           GROUP BY CDLISTA) CF,
                          (SELECT NVL(TRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, P_CDIMPOSTO, 'B','1'),2)),0) AS VRBASECALCICMS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_ICMS_SUB, 'B','1'),2)),0,''),0) AS VRBASECALCSUB,
                                  NVL(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, P_CDIMPOSTO, 'I','1'),2)),0) AS VRICMS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_ICMS_SUB, 'I','1'),2)),0,''),0) AS VRSUB,
                                  NVL(LTRIM(ROUND(N.VRPRODUTOS,2)),0) AS VRPRODUTOS,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '01'),2)),0) AS VRFRETE,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '08'),2)),0) AS VRSEGURO,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A'),2)),0) AS VROUTROS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_IPI, 'I','1'),2)),0,''),0)  AS VRIPI,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D'),2)),0) AS DESCONTO,
                                  L.CDLISTA
                             FROM NOTAFISCAL N, LISTA L
                            WHERE N.CDINSCESTA   = P_CDINSCESTA
                              AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND N.IDENTRSAIDOP = 'S'
                              AND L.NRLISTA      = P_NRLISTA) VR, 
                          (SELECT SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),1,8)  || '|' || 
                                  SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),9,4)  || '|' || 
                                  SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),13,2) || '|' || 
                                  SUBSTR(T.NMRAZSOCTRAN,1,150)  || '|' || 
                                  T.SGESTADO                    || '|' || 
                                  M.NMMUNICIPIO                 || '|' || 
                                  ''                            || '|' || 
                                  DSESPECVOLU                   || '|' || 
                                  DECODE(LTRIM(TO_CHAR(ROUND(N.VRPBRUTOVOLU,3),'99999990.000')),'0.000','')     || '|' || 
                                  DECODE(LTRIM(TO_CHAR(ROUND(N.VRPLIQUVOLU,3),'99999990.000')),'0.000','')      || '|' || 
                                  N.NRPLACAVEIC                 || '|' || 
                                  N.SGUFVEIC                    || '|' || 
                                  ''                            || '|' || 
                                  ''                      AS DADOS_TRANS, 
                                  N.NRINSJURTRAN, NRINSESTTRAN, N.IDTPIJURTRAN
                             FROM NOTAFISCAL N, TRANSPORT T, LISTA L, 
                                  (SELECT M.NMMUNICIPIO, T.NRINSJURTRAN, T.IDTPIJURTRAN
                                     FROM TRANSPORT T, MUNICIPIO M
                                    WHERE T.CDMUNICIPIO(+)  = M.CDMUNICIPIO
                                      AND T.SGESTADO(+)     = M.SGESTADO
                                      AND T.CDPAIS(+)       = M.CDPAIS)M
                            WHERE N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND L.NRLISTA      = P_NRLISTA
                              AND N.NRINSJURTRAN = T.NRINSJURTRAN(+)
                              AND N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)
                              AND N.CDINSCESTA   = P_CDINSCESTA
                              AND N.IDENTRSAIDOP = 'S'
                              AND M.NRINSJURTRAN = T.NRINSJURTRAN
                              AND M.IDTPIJURTRAN = T.IDTPIJURTRAN) T
                    WHERE N.CDINSCESTA   = P_CDINSCESTA
                      AND N.IDENTRSAIDOP = 'S'
                      AND N.CDFORNECED    = F.CDFORNECED
                      AND F.CDFORNECED    = EF.CDFORNECED
                      AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                      AND L.NRLISTA      = P_NRLISTA
                      AND N.NRINSJURTRAN = T.NRINSJURTRAN(+)
                      AND N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)
                      AND CF.CDLISTA     = L.CDLISTA
                      AND VR.CDLISTA     = L.CDLISTA
                      AND EF.CDMUNICIPIO = M.CDMUNICIPIO
                      AND EF.SGESTADO    = M.SGESTADO
                      AND EF.CDPAIS      = M.CDPAIS
                      AND IE.CDEMPRESA   = P_CDEMPRESA
                      AND IE.CDINSCESTA  = P_CDINSCESTA
                      AND EF.IDTPENDEFORN(+) = 'P'
                    
                   UNION
                   
                   /*Notas de Entrada*/
                   SELECT '1'                                                                            || '|' || 
                          LTRIM(TO_CHAR(SUBSTR(LPAD(N.NRNOTAFISC,10,'0'),2,9),'999999990'))              || '|' || 
                          SUBSTR(DECODE(N.CDSERIEENTR,'-','',N.CDSERIEENTR),1,4)                         || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),1,8)   || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),9,4)   || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),13,2)  || '|' || 
                          TO_CHAR(N.DTEMISSAO, 'DD/MM/YYYY')                                             || '|' || 
                          DECODE(EF.SGESTADO,'BA',SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSESTFORN,'-',''),'/',''),'.',''),1,9),'')    || '|' || 
                          EF.SGESTADO                                                                    || '|' || 
                          TO_CHAR (N.DTENTRSAID,'DD/MM/YYYY')                                            || '|' || 
                          CF.CDFISCOPERNF                                                                || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRBASECALCICMS,0),2),'99999999999990.00'))          || '|' || 
                          DECODE(NVL(VR.VRBASECALCSUB,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRBASECALCSUB,0),2),'99999999999990.00'))) || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRICMS,0),2),'999999999990.00'))                    || '|' || 
                          DECODE(NVL(VR.VRSUB,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRSUB,0),2),'999999999990.00')))                   || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRPRODUTOS,0),2),'99999999999990.00'))              || '|' || 
                          DECODE(NVL(VR.VRFRETE,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRFRETE,0),2),'999999999990.00')))               || '|' || 
                          DECODE(NVL(VR.VRSEGURO,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRSEGURO,0),2),'999999999990.00')))             || '|' || 
                          DECODE(NVL(VR.VROUTROS,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VROUTROS,0),2),'99999999999990.00')))           || '|' || 
                          DECODE(NVL(VR.VRIPI,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.VRIPI,0),2),'999999999990.00')))                   || '|' ||
                          LTRIM(TO_CHAR(ROUND((NVL(VR.VRPRODUTOS,0)+NVL(VR.VRFRETE,0)+NVL(VR.VRSEGURO,0)+NVL(VR.VROUTROS,0)+NVL(VR.VRIPI,0)+NVL(VR.VRSUB,0)),2),'999999999990.00')) || '|' || 
                          DECODE(EF.SGESTADO,'BA',SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSESTTRAN,'-',''),'/',''),'.',''),1,9),'')    || '|' ||
                          NVL(T.DADOS_TRANS, '|||||||||||||')                                            || '|' || 
                          DECODE(N.IDPGTOFRETE,'1','0','1')                                              || '|' || 
                          ''                                                                             || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),1,8)  || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),9,4)  || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),13,2) || '|' || 
                          E.NMRAZSOCEMPR                                                                 || '|' || 
                          IE.DSENDEIEST                                                                  || '|' || 
                          SUBSTR(IE.NMBAIRIEST,1,40)                                                     || '|' || 
                          SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRCEPIEST,'-',''),'.',''),' ',''),1,10)      || '|' || 
                          DECODE(SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(IE.NRTELEIEST,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),2,2),'00','',SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(IE.NRTELEIEST,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),2,2))  || '|' ||
                          SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(IE.NRTELEIEST,'(',''),')',''),'-',''),' ',''),'.',''),11,'0'),4,8)   || '|' || 
                          IE.SGESTADO                                                                    || '|' || 
                          M.NMMUNICIPIO                                                                  || '|' || 
                          ''                                                                             || '|' || 
                          LTRIM(TO_CHAR(ROUND(NVL(VR.VRPRODUTOS,0)+NVL(VR.VRFRETE,0)+NVL(VR.VRSEGURO,0)+NVL(VR.VROUTROS,0)+NVL(VR.VRIPI,0)+NVL(VR.VRSUB,0)-NVL(VR.DESCONTO,0),2),'99999999999990.00')) || '|' ||
                          DECODE(NVL(VR.DESCONTO,0),0,'',LTRIM(TO_CHAR(ROUND(NVL(VR.DESCONTO,0),2),'99999999999990.00')))           || '|' || 
                          '0'                                                                            || '|' || 
                          ''                                                                             || '|' || 
                          ''                                                                             || '|' || 
                          ''                                                                             || '|' || 
                          ''                                                                             || '|' AS DADOS_NOTA, 
                          L.CDLISTA
                     FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN EF, LISTA L, MUNICIPIO M, INSCRESTAD IE, EMPRESA E,
                          (SELECT MAX (I.CDFISCOPERNF) AS CDFISCOPERNF, CDLISTA   
                             FROM NOTAFISCAL N, IMPOSTONF I, LISTA L
                            WHERE N.CDINSCESTA   = P_CDINSCESTA
                              AND N.CDFILIAL     = I.CDFILIAL
                              AND N.IDENTRSAIDOP = 'E'
                              AND N.NRLANCTONF   = I.NRLANCTONF 
                              AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND L.NRLISTA      = P_NRLISTA
                            GROUP BY CDLISTA) CF,
                          (SELECT NVL(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, P_CDIMPOSTO, 'B','1'),2)),0) AS VRBASECALCICMS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_ICMS_SUB, 'B','1'),2)),0,''),0) AS VRBASECALCSUB,
                                  NVL(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, P_CDIMPOSTO, 'I','1'),2)),0) AS VRICMS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_ICMS_SUB, 'I','1'),2)),0,''),0) AS VRSUB,
                                  NVL(LTRIM(ROUND(N.VRPRODUTOS,2)),0) AS VRPRODUTOS,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '01'),2)),0) AS VRFRETE,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A', '08'),2)),0) AS VRSEGURO,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'A'),2)),0) AS VROUTROS,
                                  NVL(DECODE(LTRIM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, V_IPI, 'I','1'),2)),0,''),0)  AS VRIPI,
                                  NVL(LTRIM(ROUND(VALOR_ENCARGO(N.CDFILIAL, N.NRLANCTONF, 'D'),2)),0) AS DESCONTO,
                                  L.CDLISTA
                             FROM NOTAFISCAL N, LISTA L
                            WHERE N.CDINSCESTA   = P_CDINSCESTA
                              AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND N.IDENTRSAIDOP = 'E'
                              AND L.NRLISTA      = P_NRLISTA) VR, 
                          (SELECT SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),1,8)  || '|' || 
                                  SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),9,4)  || '|' || 
                                  SUBSTR(REPLACE(REPLACE(REPLACE(T.NRINSJURTRAN, '/', ''),'-',''),'.',''),13,2) || '|' || 
                                  SUBSTR(T.NMRAZSOCTRAN,1,150)  || '|' || 
                                  T.SGESTADO                    || '|' || 
                                  M.NMMUNICIPIO                 || '|' || 
                                  ''                            || '|' || 
                                  DSESPECVOLU                   || '|' || 
                                  DECODE(LTRIM(TO_CHAR(ROUND(N.VRPBRUTOVOLU,3),'99999990.000')),'0.000','')     || '|' || 
                                  DECODE(LTRIM(TO_CHAR(ROUND(N.VRPLIQUVOLU,3),'99999990.000')),'0.000','')      || '|' || 
                                  N.NRPLACAVEIC                 || '|' || 
                                  N.SGUFVEIC                    || '|' || 
                                  ''                            || '|' || 
                                  ''                      AS DADOS_TRANS, 
                                  N.NRINSJURTRAN, NRINSESTTRAN, N.IDTPIJURTRAN
                             FROM NOTAFISCAL N, TRANSPORT T, LISTA L, 
                                  (SELECT M.NMMUNICIPIO, T.NRINSJURTRAN, T.IDTPIJURTRAN
                                     FROM TRANSPORT T, MUNICIPIO M
                                    WHERE T.CDMUNICIPIO(+)  = M.CDMUNICIPIO
                                      AND T.SGESTADO(+)     = M.SGESTADO
                                      AND T.CDPAIS(+)       = M.CDPAIS)M
                            WHERE N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                              AND L.NRLISTA      = P_NRLISTA
                              AND N.NRINSJURTRAN = T.NRINSJURTRAN(+)
                              AND N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)
                              AND N.CDINSCESTA   = P_CDINSCESTA
                              AND N.IDENTRSAIDOP = 'E'
                              AND M.NRINSJURTRAN = T.NRINSJURTRAN
                              AND M.IDTPIJURTRAN = T.IDTPIJURTRAN) T
                    WHERE N.CDINSCESTA    = P_CDINSCESTA
                      AND N.IDENTRSAIDOP  = 'E'
                      AND N.CDFORNECED    = F.CDFORNECED
                      AND F.CDFORNECED    = EF.CDFORNECED
                      AND N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                      AND L.NRLISTA       = P_NRLISTA
                      AND N.NRINSJURTRAN  = T.NRINSJURTRAN(+)
                      AND N.IDTPIJURTRAN  = T.IDTPIJURTRAN(+)
                      AND CF.CDLISTA      = L.CDLISTA
                      AND VR.CDLISTA      = L.CDLISTA
                      AND IE.CDMUNICIPIO  = M.CDMUNICIPIO
                      AND IE.SGESTADO     = M.SGESTADO
                      AND IE.CDPAIS       = M.CDPAIS
                      AND IE.CDEMPRESA    = P_CDEMPRESA
                      AND IE.CDINSCESTA   = P_CDINSCESTA
                      AND IE.CDEMPRESA    = E.CDEMPRESA
                      AND EF.IDTPENDEFORN(+) = 'P')LOOP
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (V_CONTADOR, C_NOTAS.DADOS_NOTA, P_NRSEQARQMAG);
      V_CONTADOR := NVL(V_CONTADOR,0)+1;
       /*REGISTRO 2 - Dados do Item*/
       FOR C_ITENS IN (/*Notas de Sada*/ 
                       SELECT '2'                                                                                                || '|' || 
                              LTRIM(TO_CHAR(SUBSTR(LPAD(N.NRNOTAFISC,10,'0'),2,9),'999999990'))                                  || '|' || 
                              SUBSTR(DECODE(N.CDSERIE,'-','', N.CDSERIE),1,4)                                                    || '|' || 
                              SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),1,8)                      || '|' || 
                              SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),9,4)                      || '|' || 
                              SUBSTR(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST, '/', ''),'-',''),'.',''),13,2)                     || '|' || 
                              TO_CHAR(N.DTEMISSAO, 'DD/MM/YYYY')                                                                 || '|' || 
                              I.NRSEQITPROD                                                                                      || '|' || 
                              P.CDARVPROD                                                                                        || '|' || 
                              P.NMPRODUTO                                                                                        || '|' || 
                              I.CDSITUTRIBPR                                                                                     || '|' || 
                              P.SGUNIDADE                                                                                        || '|' || 
                              NVL(LTRIM(TO_CHAR(ROUND(I.QTITEMPROD,6),'99999999999990.000000')),'0.000000')                      || '|' || 
                              NVL(LTRIM(TO_CHAR(ROUND(I.VRUNITITEM,6),'99999999999990.000000')),'0.000000')                      || '|' || 
                              DECODE(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, V_IPI, 'A','1'),0,'',LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, V_IPI, 'A','1'),6),'99990.00')))             || '|' || 
                              DECODE(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, P_CDIMPOSTO, 'A','1'),0,'',LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, P_CDIMPOSTO, 'A','1'),6),'99990.00'))) || '|' || 
                              DECODE(I.VRDESCITEM,0,'',LTRIM(TO_CHAR(ROUND(I.VRDESCITEM,6),'99999999999990.000000')))            || '|' ||
                              ''                                                                                                 || '|' ||
                              NVL(LTRIM(TO_CHAR(ROUND(NVL(I.QTITEMPROD,0)*NVL(I.VRUNITITEM,0),2),'99999999999990.00')),'0.00')   || '|' || 
                              NVL(LTRIM(TO_CHAR(ROUND((NVL(I.QTITEMPROD,0)*NVL(I.VRUNITITEM,0))-NVL(I.VRDESCITEM,0),2),'99999999999990.00')),'0.00')        || '|' AS DADOS_ITEM
                         FROM NOTAFISCAL N, INSCRESTAD IE, ITEMPRODUTO I, PRODUTO P, LISTA L
                        WHERE N.CDINSCESTA    = P_CDINSCESTA
                          AND N.IDENTRSAIDOP  = 'S'
                          AND N.CDFILIAL||N.NRLANCTONF = C_NOTAS.CDLISTA
                          AND C_NOTAS.CDLISTA = L.CDLISTA
                          AND L.NRLISTA       = P_NRLISTA
                          AND IE.CDEMPRESA    = P_CDEMPRESA
                          AND IE.CDINSCESTA   = P_CDINSCESTA
                          AND N.CDFILIAL      = I.CDFILIAL
                          AND N.NRLANCTONF    = I.NRLANCTONF
                          AND P.CDPRODUTO     = I.CDPRODUTO 
                          
                       UNION
      
                       /*Notas de Entrada*/
                       SELECT '2'                                                                                                || '|' || 
                              LTRIM(TO_CHAR(SUBSTR(LPAD(N.NRNOTAFISC,10,'0'),2,9),'999999990'))                                  || '|' || 
                              SUBSTR(DECODE(N.CDSERIEENTR,'-','',N.CDSERIEENTR),1,4)                                             || '|' || 
                              SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),1,8)                       || '|' || 
                              SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),9,4)                       || '|' || 
                              SUBSTR(REPLACE(REPLACE(REPLACE(F.NRINSJURFORN, '/', ''),'-',''),'.',''),13,2)                      || '|' || 
                              TO_CHAR(N.DTEMISSAO, 'DD/MM/YYYY')                                                                 || '|' || 
                              I.NRSEQITPROD                                                                                      || '|' || 
                              P.CDARVPROD                                                                                        || '|' || 
                              P.NMPRODUTO                                                                                        || '|' || 
                              I.CDSITUTRIBPR                                                                                     || '|' || 
                              P.SGUNIDADE                                                                                        || '|' || 
                              NVL(LTRIM(TO_CHAR(ROUND(I.QTITEMPROD,6),'99999999999990.000000')),'0.000000')                      || '|' || 
                              NVL(LTRIM(TO_CHAR(ROUND(I.VRUNITITEM,6),'99999999999990.000000')),'0.000000')                      || '|' || 
                              DECODE(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, V_IPI, 'A','1'),0,'',LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, V_IPI, 'A','1'),6),'99990.00')))             || '|' || 
                              DECODE(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, P_CDIMPOSTO, 'A','1'),0,'',LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, P_CDIMPOSTO, 'A','1'),6),'99990.00'))) || '|' || 
                              DECODE(I.VRDESCITEM,0,'',LTRIM(TO_CHAR(ROUND(I.VRDESCITEM,6),'99999999999990.000000')))            || '|' ||
                              ''                                                                                                 || '|' || 
                              NVL(LTRIM(TO_CHAR(ROUND(NVL(I.QTITEMPROD,0)*NVL(I.VRUNITITEM,0),2),'99999999999990.00')),'0.00')   || '|' || 
                              NVL(LTRIM(TO_CHAR(ROUND((NVL(I.QTITEMPROD,0)*NVL(I.VRUNITITEM,0))-NVL(I.VRDESCITEM,0),2),'99999999999990.00')),'0.00')        || '|' AS DADOS_ITEM 
                         FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN EF, ITEMPRODUTO I, PRODUTO P, LISTA L
                        WHERE N.CDINSCESTA    = P_CDINSCESTA
                          AND N.IDENTRSAIDOP  = 'E'
                          AND N.CDFILIAL||N.NRLANCTONF = C_NOTAS.CDLISTA
                          AND C_NOTAS.CDLISTA= L.CDLISTA 
                          AND L.NRLISTA       = P_NRLISTA
                          AND N.CDFORNECED    = F.CDFORNECED
                          AND F.CDFORNECED    = EF.CDFORNECED 
                          AND N.CDFILIAL      = I.CDFILIAL
                          AND N.NRLANCTONF    = I.NRLANCTONF
                          AND P.CDPRODUTO     = I.CDPRODUTO
                          AND EF.IDTPENDEFORN(+) = 'P')LOOP
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
       VALUES
          (V_CONTADOR, C_ITENS.DADOS_ITEM, P_NRSEQARQMAG);
           V_CONTADOR := NVL(V_CONTADOR,0)+1;                        
       END LOOP;  
   END LOOP;
END;
/
